#include "window.hh"

class Matrix
{
private:
	typedef double matx[4][4];
	matx dah;
public:
	Matrix(double ax,double ay,double az)
    {
        matx m[3];

        register int i, j;

        memset(&m, 0, sizeof(m));

        m[0][1][1]=m[0][2][2]=cos(ax); m[0][2][1]=-(m[0][1][2]=sin(ax));
        m[1][0][0]=m[1][2][2]=cos(ay); m[1][0][2]=-(m[1][2][0]=sin(ay));
        m[2][0][0]=m[2][1][1]=cos(az); m[2][1][0]=-(m[2][0][1]=sin(az));
     
        m[0][0][0] = m[0][3][3] = 1;
        m[1][1][1] = m[1][3][3] = 1;
        m[2][2][2] = m[2][3][3] = 1;
     
        for(i=0; i<4; i++)
        {
            double m2[4];

            for(j=0; j<4; j++)
                m2[j] = m[1][i][0] * m[0][0][j]  +  m[1][i][1] * m[0][1][j] +
                        m[1][i][2] * m[0][2][j]  +  m[1][i][3] * m[0][3][j];

            for(j=0; j<4; j++)
                dah[i][j] = m2[0] * m[2][0][j]  +  m2[1] * m[2][1][j] +
                            m2[2] * m[2][2][j]  +  m2[3] * m[2][3][j];
        }
    }
	void RotatePoint(double &x,double &y,double &z)
	{
	    register double tx = x*dah[0][0] + y*dah[1][0] + z*dah[2][0] + dah[3][0];
	    register double ty = x*dah[0][1] + y*dah[1][1] + z*dah[2][1] + dah[3][1];
	
	    z = x*dah[0][2] + y*dah[1][2] + z*dah[2][2] + dah[3][2];
	    y = ty;
	    x = tx;
	}
};

class demowin : public window
{
    class line
    {
    	double x1,y1,z1, x2,y2,z2;
    	int isline, color;
    public:
    	line(double X1,double Y1,double Z1, double X2,double Y2,double Z2) : isline(1)
    	{
    		x1 = (X1/31 - 0.5) * 20;
    		y1 = (Y1/11 - 0.5) * 20;
    		z1 = Z1;
    		x2 = (X2/31 - 0.5) * 20;
    		y2 = (Y2/11 - 0.5) * 20;
    		z2 = Z2;
    	}
    	line(double x,double y,double z, int c) : x1(x),y1(y),z1(z),isline(0),color(c)
    	{
    	}
    	void Draw(demowin *w, double cx,double cy,double cz, Matrix &m);
    };
    friend line;

    class World
    {
    private:
    	vector <line *> lines;
    public:
    	typedef vector<line*>::iterator iterator;
    	void Insert(line *Line)
    	{
    		lines.insert(lines.end(), Line);
    	}
    	void AddPoly(int x,int y, ...);
    	iterator begin(void) { return lines.begin(); }
    	iterator end(void)   { return lines.end();   }
    } World;
private:
   	double ax,ay,az;
   	double cx,cy,cz;
   	unsigned EL,EC;
    int EC2,EL3;
	char *Field, *Color, *efi;

	void Init();
    void Done();
    inline int SetP(int x,int y)
    {
    	if(x<0||y<0||x>=EC2||y>=EL3-9)return 0;
    	Field[EC * y + (x>>1)] |= 1 << (x&1);
    	return 1;
    }
    inline void PSet(float x,float y, int c)
    {
    	register int X = int(x*(EC2));
    	register int Y = int(y*(EL3));
    	if(SetP(X, Y))
    		Color[EC * (Y/3) + (X>>1)] = c;
    }
    void Line(double X1,double Y1, double X2,double Y2);
    void Initialize();
public:
	demowin() 
	{
		Initialize();
	}
	demowin(unsigned x, unsigned y) : window(x, y)
	{
		Initialize();
	}
	virtual ~demowin();
	
	virtual void handleevent(event &e);
};

